

#property indicator_chart_window
#property indicator_buffers  1
#property indicator_color1   EMPTY
extern string TimeFrame    = "W1";
extern double   ExtDepth     = 61.8;
extern int    ExtDeviation = 5;
extern int    ExtBackstep  = 3;

double zigzag[];
double ExtMapBuffer2x[];
int OldLastZigZagx, OldPreviousZigZagx;
int    timeFrame;
int deinit() {

}
//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
  
  
   SetIndexBuffer(0,zigzag); SetIndexStyle(0,DRAW_SECTION); SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,ExtMapBuffer2x);  
      timeFrame = stringToTimeFrame(TimeFrame);
   return(0);
}



int start()
{
   int count,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
         for (count=0;limit<(Bars-1) && count<3; limit++)  if (zigzag[limit]!=0) count++;
  

   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
         if (x!=y)
              
              
               zigzag[i] = iCustom(NULL,timeFrame,"ZZ_MidtermFibo",ExtDepth,ExtDeviation,ExtBackstep,0,y);
         else  zigzag[i] = 0;
   }         
      WindowRedraw(); 
         
return(0);
}

    

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};



int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}



string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}