#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 EMPTY
//---- indicator parameters
extern double ExtDepthx=161.8;        
extern double ExtDeviationx=0.5;
extern int ExtBackstepx=3;
//---- indicator buffers




 
double ExtMapBufferx[];
double ExtMapBuffer2x[];
 
int OldLastZigZagx, OldPreviousZigZagx;
double zigzag[];
int    timeFrame;  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION,3);  //Zig Zag Line; 0 = Line true, 1 =  line false
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBufferx);
   SetIndexBuffer(1,ExtMapBuffer2x);
   SetIndexEmptyValue(0,0.0);
   ArraySetAsSeries(ExtMapBufferx,true);
   ArraySetAsSeries(ExtMapBuffer2x,true);
   
  
   
//---- initialization done
   return(0);
  }
  
int deinit() {
	ObjectDelete("Monthly");
	
	ObjectDelete("23.6% Monthly S/R ");
	ObjectDelete("38.2% Monthly S/R ");
   ObjectDelete("50.0% Monthly S/R ");
   ObjectDelete("61.8% Monthly S/R ");
   ObjectDelete("76.4% Monthly S/R ");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  
 int    shiftx, backx,lasthighposx,lastlowposx;
   double valx,resx;
   double curlowx,curhighx,lasthighx,lastlowx;

 
      for(shiftx=Bars-ExtDepthx; shiftx>=0; shiftx--)
     {
      valx=Low[Lowest(NULL,0,MODE_LOW,ExtDepthx,shiftx)];
      if(valx==lastlowx) valx=0.0;
      else 
        { 
         lastlowx=valx; 
         if((Low[shiftx]-valx)>(ExtDeviationx*Point)) valx=0.0;
         else
           {
            for(backx=1; backx<=ExtBackstepx; backx++)
              {
               resx=ExtMapBufferx[shiftx+backx];
               if((resx!=0)&&(resx>valx)) ExtMapBufferx[shiftx+backx]=0.0; 
              }
           }
        } 
      ExtMapBufferx[shiftx]=valx;
      //--- high
      valx=High[Highest(NULL,0,MODE_HIGH,ExtDepthx,shiftx)];
      if(valx==lasthighx) valx=0.0;
      else 
        {
         lasthighx=valx;
         if((valx-High[shiftx])>(ExtDeviationx*Point)) valx=0.0;
         else
           {
            for(backx=1; backx<=ExtBackstepx; backx++)
              {
               resx=ExtMapBuffer2x[shiftx+backx];
               if((resx!=0)&&(resx<valx)) ExtMapBuffer2x[shiftx+backx]=0.0; 
              } 
           }
        }
      ExtMapBuffer2x[shiftx]=valx;
     }

   // final cutting 
   lasthighx=-1; lasthighposx=-1;
   lastlowx=-1;  lastlowposx=-1;

   for(shiftx=Bars-ExtDepthx; shiftx>=0; shiftx--)
     {
      curlowx=ExtMapBufferx[shiftx];
      curhighx=ExtMapBuffer2x[shiftx];
      if((curlowx==0)&&(curhighx==0)) continue;
      //---
      if(curhighx!=0)
        {
         if(lasthighx>0) 
           {
            if(lasthighx<curhighx) ExtMapBuffer2x[lasthighposx]=0;
            else ExtMapBuffer2x[shiftx]=0;
           }
         //---
         if(lasthighx<curhighx || lasthighx<0)
           {
            lasthighx=curhighx;
            lasthighposx=shiftx;
           }
         lastlowx=-1;
        }
      //----
      if(curlowx!=0)
        {
         if(lastlowx>0)
           {
            if(lastlowx>curlowx) ExtMapBufferx[lastlowposx]=0;
            else ExtMapBufferx[shiftx]=0;
           }
         //---
         if((curlowx<lastlowx)||(lastlowx<0))
           {
            lastlowx=curlowx;
            lastlowposx=shiftx;
           } 
         lasthighx=-1;
        }
     }
  
   for(shiftx=Bars-1; shiftx>=0; shiftx--)
     {
      if(shiftx>=Bars-ExtDepthx) ExtMapBufferx[shiftx]=0.0;
      else
        {
         resx=ExtMapBuffer2x[shiftx];
         if(resx!=0.0) ExtMapBufferx[shiftx]=resx;
        }

     } 
     
 	int ix=0;
  	int LastZigZagx, PreviousZigZagx;
   
   int hx=0;
   while ( ExtMapBufferx[hx]==0 && ExtMapBufferx[hx]==0) {
   	hx++;
   }
   
   LastZigZagx=hx;
   
   hx++;
   while(ExtMapBufferx[hx]==0 && ExtMapBuffer2x[hx]==0) {
   	hx++;
   }
   
   PreviousZigZagx=hx;
   
   if (LastZigZagx!=OldLastZigZagx || PreviousZigZagx!=OldPreviousZigZagx) {
   	
   	OldLastZigZagx=LastZigZagx;
   	OldPreviousZigZagx=PreviousZigZagx;
     
   if (LastZigZagx!=OldLastZigZagx || PreviousZigZagx!=OldPreviousZigZagx) {
   	
   	OldLastZigZagx=LastZigZagx;
   	OldPreviousZigZagx=PreviousZigZagx;
   	
                                //time1  price         time2        price 2  
      ObjectCreate("Monthly", OBJ_FIBO, 0, Time[PreviousZigZagx], ExtMapBufferx[PreviousZigZagx], 
                                                   Time[LastZigZagx], ExtMapBufferx[LastZigZagx]);}
      
    	ObjectDelete("Monthly");
   	ObjectCreate("Monthly", OBJ_FIBO, 0, Time[PreviousZigZagx], ExtMapBufferx[PreviousZigZagx], 
   	                                             Time[LastZigZagx], ExtMapBufferx[LastZigZagx]);
     
      double fiboPrice1=ObjectGet("Monthly",OBJPROP_PRICE1);
      double fiboPrice2=ObjectGet("Monthly",OBJPROP_PRICE2);
      double   FIBO236x   = fiboPrice2 + 0.236 * (fiboPrice1 - fiboPrice2);// price at  23.6
      double   FIBO382x   = fiboPrice2 + 0.382 * (fiboPrice1 - fiboPrice2);// price at  38.2 
      double   FIBO50x    = fiboPrice2 + 0.50  * (fiboPrice1 - fiboPrice2);// price at  50.0 
      double   FIBO618x   = fiboPrice2 + 0.618 * (fiboPrice1 - fiboPrice2);// price at  61.8
      double   FIBO764x   = fiboPrice2 + 0.764 * (fiboPrice1 - fiboPrice2);// price at  76.4
    
     ObjectSet("Monthly",OBJPROP_FIBOLEVELS,6);
     ObjectSet("Monthly",OBJPROP_FIRSTLEVEL+0,0.236);
     ObjectSet("Monthly",OBJPROP_FIRSTLEVEL+2,0.382);
     ObjectSet("Monthly",OBJPROP_FIRSTLEVEL+3,0.50);
     ObjectSet("Monthly",OBJPROP_FIRSTLEVEL+4,0.618);
     ObjectSet("Monthly",OBJPROP_FIRSTLEVEL+5,0.764);
  
     ObjectSet("Monthly",OBJPROP_COLOR,EMPTY);
     ObjectSet("Monthly",OBJPROP_LEVELCOLOR,EMPTY);
     ObjectSet("Monthly",OBJPROP_LEVELWIDTH,2);
     ObjectSet("Monthly",OBJPROP_LEVELSTYLE,STYLE_SOLID);
    /* ObjectSetFiboDescription( "Fibonacci Linesx1", 5,"     76.4 >          "); 
     ObjectSetFiboDescription( "Fibonacci Linesx1", 4,"     61.8 >          "); 
     ObjectSetFiboDescription( "Fibonacci Linesx1", 3,"     50.0 >          ");
     ObjectSetFiboDescription( "Fibonacci Linesx1", 2,"     38.2 >          ");
     ObjectSetFiboDescription( "Fibonacci Linesx1", 0,"     23.6 >          ");*/
   
      //----
         if(ObjectFind("23.6% Monthly S/R ") != 0)
         {
           ObjectCreate("23.6% Monthly S/R ", OBJ_HLINE, 0, Time[0], FIBO236x);
           ObjectSet("23.6% Monthly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("23.6% Monthly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("23.6% Monthly S/R ", 0, Time[0], FIBO236x);
         }
       
      //----
         if(ObjectFind("38.2% Monthly S/R ") != 0)
         {
           ObjectCreate("38.2% Monthly S/R ", OBJ_HLINE, 0, Time[0], FIBO382x);
           ObjectSet("38.2% Monthly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("38.2% Monthly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("38.2% Monthly S/R ", 0, Time[0], FIBO382x);
         }
       //----
       if(ObjectFind("50.0% Monthly S/R ") != 0)
         {
           ObjectCreate("50.0% Monthly S/R ", OBJ_HLINE, 0, Time[0], FIBO50x);
           ObjectSet("50.0% Monthly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("50.0% Monthly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("50.0% Monthly S/R ", 0, Time[0], FIBO50x);
         }
       //----
   
   if(ObjectFind("61.8% Monthly S/R ") != 0)
         {
           ObjectCreate("61.8% Monthly S/R ", OBJ_HLINE, 0, Time[0], FIBO618x);
           ObjectSet("61.8% Monthly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("61.8% Monthly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("61.8% Monthly S/R ", 0, Time[0], FIBO618x);
         }
       //----
    if(ObjectFind("76.4% Monthly S/R ") != 0)
         {
           ObjectCreate("76.4% Monthly S/R ", OBJ_HLINE, 0, Time[0], FIBO764x);
           ObjectSet("76.4% Monthly S/R ", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("76.4% Monthly S/R ", OBJPROP_COLOR, Red);
         }
       else
         {
           ObjectMove("76.4% Monthly S/R ", 0, Time[0], FIBO764x);
         }
        WindowRedraw(); 
       
       //----
   
   }                               
}                                  
  


